<?php

/**
 * inf_investiga_bienes actions.
 *
 * @package    cobro_coactivo
 * @subpackage inf_investiga_bienes
 * @author     ManuelEnrique ParedesLopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_investiga_bienesActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_INVESTIGA_BIENES',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ENTIDAD_IB',
        'CBR_ABOGADO_ULT_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_INVESTIGA_BIENES'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ENTIDAD_IB' =>
        array(
            'id_entidad_ib' => 'CBR_INVESTIGA_BIENES'
        ),
        'CBR_ABOGADO_ULT_V,LEFT'=>
        array(
            'id_remision_titulo' => 'CBR_INVESTIGA_BIENES'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_INVESTIGA_BIENES' =>
        array(
            'id_investiga_bienes' => 'id_investiga_bienes',
            'id_remision_titulo' => 'id_remision_titulo',
            'no_oficio' => 'no_oficio',
            'fecha_envio' => 'fecha_envio',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto',
            'id_entidad_ib' => 'id_entidad_ib',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral'
        ),
        'CBR_ENTIDAD_IB' =>
        array(
            'descripcion' => 'descripcion_entidad'
        ),
        'CBR_ABOGADO_ULT_V' =>
        array(
            'razon_soc' => 'abogado'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_INVESTIGA_BIENES' =>
        array(
            'id_investiga_bienes,a' => array('!=' => array(-1)),
            'id_investiga_bienes,b' => array('=' => array('id_investiga_bienes')),
            'id_remision_titulo' => array('=' => array('id_remision_titulo')),
            'fecha_log' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_entidad_ib' => array('=' => array('id_entidad_ib')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_ABOGADO_ULT_V'=>
        array(
            'id_abogado' => array('=' => array('id_abogado')),
            'num_doc' => array('IN' => array('num_doc'))
        ),
        'CBR_REMISION_TITULO'=>
        array(
            'numero_remision' => array('=' => array('numero_remision')),
            'cod_titulo' => array('=' => array('cod_titulo')),
            'id_par' => array('=' => array('id_par'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_investiga_bienes'; //identificador de la tabla
    protected $id_names = array('id_investiga_bienes'); //llave primaria
    protected $field_names = array('id_remision_titulo', 'id_entidad_ib', 'no_oficio',
        'fecha_envio', 'observaciones', 'adjunto', 'usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_INVESTIGA_BIENES'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_investiga_bienes'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

          
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

          
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;
        
        /*
         *  Validar la operación, ya sea por SQL
         */
        

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
